/*
 * Doom2D:Vaya Con Dios
 *
 * Copyright (C) Ketmar Dark 2013
 *
 * coded by Ketmar // Vampire Avalon (psyc://ketmar.no-ip.org/~Ketmar)
 * Understanding is not required. Only obedience.
 *
 * This program is free software. It comes without any warranty, to
 * the extent permitted by applicable law. You can redistribute it
 * and/or modify it under the terms of the Do What The Fuck You Want
 * To Public License, Version 2, as published by Sam Hocevar. See
 * http://www.wtfpl.net/ for more details.
 */
#ifndef SDL_DRIVER_H
#define SDL_DRIVER_H

#include <stdlib.h>
#include <string.h>

#include "SDL.h"

#ifdef __cplusplus
extern "C" {
#endif


////////////////////////////////////////////////////////////////////////////////
enum {
  MS_BUTTON_LEFT      = 0x01,
  MS_BUTTON_RIGHT     = 0x02,
  MS_BUTTON_MIDDLE    = 0x04,
  MS_BUTTON_WHEELUP   = 0x10,
  MS_BUTTON_WHEELDOWN = 0x20,
  //
  MS_BUTTON_AUTO      = 0x80, // autogenerated mouse press
  //
  MS_BUTTON_MASK = 0xff, // ignore 'depressed' flag for mouseButtonCB
  MS_BUTTON_DEPRESSED = 0x100,
};


//typedef void (*FrameCB) (void);
typedef void (*KeyCB) (SDL_KeyboardEvent *key);
typedef void (*MouseCB) (int x, int y, int xrel, int yrel, int buttons);
typedef void (*MouseButtonCB) (int x, int y, int button, int buttons);
typedef void (*WindowActivationCB) (int activated);


//extern FrameCB frameCB;
extern KeyCB keyCB;
extern MouseCB mouseCB;
extern MouseButtonCB mouseButtonCB; // button: which button state was changed (possibly with MS_BUTTON_DEPRESSED)
extern WindowActivationCB windowActivationCB;
  // on deactivation, keyboard and mouse button handlers will be called for
  // pressed control keys and mouse buttons before this callback

extern int msButtons, msLastX, msLastY, kbCtrl, kbAlt, kbShift, kbSuper;
extern int kbLCtrl, kbRCtrl, kbLAlt, kbRAlt, kbLShift, kbRShift, kbLSuper, kbRSuper;
extern int msAutoTimeMSFirst; // mouse button autorepeat event time in milliseconds; <1: never
extern int msAutoTimeMSRepeat; // mouse button autorepeat event time in milliseconds; <1: never
extern int msAutoTresholdX, msAutoTresholdY;


////////////////////////////////////////////////////////////////////////////////
extern int vidWindowActivated;


////////////////////////////////////////////////////////////////////////////////
// forcedShowFrame() can be called from FrameCB to force showing the current frame
// ugly name means that you shouldn't use it
// video module will not show the frame by itself if forcedShowFrame() was called
//extern void forcedShowFrame (void);

typedef enum {
  SDLDRV_ER_QUIT = -1,
  SDLDRV_ER_OK = 0,
  SDLDRV_ER_USER_EVENT = 1
} SDLDrvEventRes;

extern void buildFrame (void);
extern SDLDrvEventRes processEvents (int dowait);
extern void postQuitMessage (void);

//extern void mainLoop (void);


#ifdef __cplusplus
}
#endif
#endif
